gi-atk-2.0.18: Atk bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria (garetxe@gmail.com)
Safe Haskell | None
Language | Haskell2010

GI.Atk.Interfaces.StreamableContent

Contents

- Exported types
- Methods
  - getMimeType
  - getNMimeTypes
  - getStream
  - getUri

Description

An interface whereby an object allows its backing content to be streamed to clients. Typical implementors would be images or icons, HTML content, or multimedia display/rendering widgets.

Negotiation of content type is allowed. Clients may examine the backing data and transform, convert, or parse the content in order to present it in an alternate form to end-users.

The AtkStreamableContent interface is particularly useful for saving, printing, or post-processing entire documents, or for persisting alternate views of a document. If document content itself is being serialized, stored, or converted, then use of the AtkStreamableContent interface can help address performance issues. Unlike most ATK interfaces, this interface is not strongly tied to the current user-agent view of the a particular document, but may in some cases give access to the underlying model data.

Synopsis

- newtype StreamableContent = StreamableContent (ManagedPtr StreamableContent)
- noStreamableContent :: Maybe StreamableContent
- class ManagedPtrNewtype a => IsStreamableContent a
- streamableContentGetMimeType :: (HasCallStack, MonadIO m, IsStreamableContent a) => a -> Int32 -> m Text
- streamableContentGetNMimeTypes :: (HasCallStack, MonadIO m, IsStreamableContent a) => a -> m Int32
- streamableContentGetStream :: (HasCallStack, MonadIO m, IsStreamableContent a) => a -> Text -> m IOChannel
- streamableContentGetUri :: (HasCallStack, MonadIO m, IsStreamableContent a) => a -> Text -> m (Maybe Text)

# Exported types

newtype StreamableContent Source #

Memory-managed wrapper type.

Constructors

StreamableContent (ManagedPtr StreamableContent) |

Instances

WrappedPtr StreamableContent Source # |
Instance details Defined in GI.Atk.Interfaces.StreamableContent Methods wrappedPtrCalloc :: IO (Ptr StreamableContent) Source # wrappedPtrCopy :: StreamableContent -> IO StreamableContent Source # wrappedPtrFree :: Maybe (FunPtr (Ptr StreamableContent -> IO ())) Source #
IsStreamableContent StreamableContent Source # |
Instance details Defined in GI.Atk.Interfaces.StreamableContent

noStreamableContent :: Maybe StreamableContent Source #

A convenience alias for `Nothing` :: `Maybe` `StreamableContent`.

class ManagedPtrNewtype a => IsStreamableContent a Source #

Type class for types which implement `StreamableContent`.

Instances

IsStreamableContent StreamableContent Source # |
Instance details Defined in GI.Atk.Interfaces.StreamableContent

# Methods

## getMimeType

streamableContentGetMimeType Source #

Arguments

:: (HasCallStack, MonadIO m, IsStreamableContent a) |
=> a | `streamable`: a GObject instance that implements AtkStreamableContent
-> Int32 | `i`: a gint representing the position of the mime type starting from 0
-> m Text | Returns: a gchar* representing the specified mime type; the caller should not free the character string.

Gets the character string of the specified mime type. The first mime type is at position 0, the second at position 1, and so on.

## getNMimeTypes

streamableContentGetNMimeTypes Source #

Arguments

:: (HasCallStack, MonadIO m, IsStreamableContent a) |
=> a | `streamable`: a GObject instance that implements AtkStreamableContentIface
-> m Int32 | Returns: a gint which is the number of mime types supported by the object.

Gets the number of mime types supported by this object.

## getStream

streamableContentGetStream Source #

Arguments

:: (HasCallStack, MonadIO m, IsStreamableContent a) |
=> a | `streamable`: a GObject instance that implements AtkStreamableContentIface
-> Text | `mimeType`: a gchar* representing the mime type
-> m IOChannel | Returns: A `IOChannel` which contains the content in the specified mime type.

Gets the content in the specified mime type.

## getUri

streamableContentGetUri Source #

Arguments

:: (HasCallStack, MonadIO m, IsStreamableContent a) |
=> a | `streamable`: a GObject instance that implements AtkStreamableContentIface
-> Text | `mimeType`: a gchar* representing the mime type, or NULL to request a URI for the default mime type.
-> m (Maybe Text) | Returns: Returns a string representing a URI, or `Nothing` if no corresponding URI can be constructed.

Get a string representing a URI in IETF standard format (see http://www.ietf.org/rfc/rfc2396.txt) from which the object's content may be streamed in the specified mime-type, if one is available. If mime_type is NULL, the URI for the default (and possibly only) mime-type is returned.

Note that it is possible for get_uri to return NULL but for get_stream to work nonetheless, since not all GIOChannels connect to URIs.

Since: 1.12